From b9a783dac7d473d8dd2bc64ddade1823866f2a23 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Mon, 06 May 2019 00:45:01 +0800
Subject: [PATCH] Add QT5 build shell script

---
 qt5/tslib/build.sh             |   90 ++++++++++++++++++
 qt5/iconv/libiconv-1.15.tar.gz |    0 
 qt5/build.sh                   |  111 ++++++++++++++++++++++
 qt5/tslib/tslib-1.16.tar.bz2   |    0 
 qt5/iconv/build.sh             |   91 ++++++++++++++++++
 5 files changed, 292 insertions(+), 0 deletions(-)

diff --git a/qt5/build.sh b/qt5/build.sh
new file mode 100755
index 0000000..7f87623
--- /dev/null
+++ b/qt5/build.sh
@@ -0,0 +1,111 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile QT5 for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+QT_INST_PATH=/apps/qt5_rpi
+LIBS_PATH=`pwd`/libs
+
+if [ -z $CROSSTOOL ] ; then
+   CROSSTOOL=/opt/rpi/arm-bcm2708/arm-linux-gnueabihf/bin/arm-linux-gnueabihf-
+fi
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_qt()
+{
+    SRC_NAME=qt-everywhere-opensource-src-5.6.1
+    PACK_SUFIX=tar.xz
+
+    #rm -rf ${QT_INST_PATH}/lib/libQt5Gui.so
+    if [ -f ${QT_INST_PATH}/lib/libQt5Gui.so ] ; then
+        msg_banner "Already cross compile $SRC_NAME "
+        return 0;
+    fi
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then 
+        msg_banner "Start download ${SRC_NAME}.${PACK_SUFIX} "
+        wget http://mirrors.ustc.edu.cn/qtproject/archive/qt/5.6/5.6.1/single/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    msg_banner "Start decompress $SRC_NAME.${PACK_SUFIX} "
+    if [ ! -d ${SRC_NAME} ] ; then
+        xz -dk ${SRC_NAME}.${PACK_SUFIX} && tar -xf ${SRC_NAME}.tar && rm -f ${SRC_NAME}.tar
+    fi
+
+    cd ${SRC_NAME}
+
+    sed -i "s|arm-linux-gnueabi-|$CROSSTOOL|" qtbase/mkspecs/linux-arm-gnueabi-g++/qmake.conf
+
+    ./configure -opensource -confirm-license -release -shared -strip -prefix ${QT_INST_PATH} -no-c++11 \
+        -xplatform linux-arm-gnueabi-g++ -qt-freetype -no-libproxy -no-avx  -make libs -optimized-qmake \
+        -qt-zlib -no-mtdev -no-gif -qt-libpng  -qt-libjpeg -no-openssl -no-cups -no-dbus -pch -qt-sql-sqlite \
+        -no-xcb -no-xcb-xlib -no-eglfs -no-kms -no-directfb -no-opengl -linuxfb -qpa linuxfb 
+        -no-sse2 -no-sse3 -no-ssse3 -no-sse4.1 -no-sse4.2 -no-rpath -no-glib -qreal float \
+        -no-xcursor -no-xfixes -no-xrandr -no-xrender -no-separate-debug-info -nomake tools -nomake examples \
+        -tslib -I${LIBS_PATH}/include/  -L${LIBS_PATH}/lib/  -I${QT_INST_PATH}/include/  -L${QT_INST_PATH}/lib/ 
+
+    msg_banner "Start cross compile $SRC_NAME "
+    make -j8 && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+    cp ./qtbase/plugins/platforms/libqlinuxfb.so  ${QT_INST_PATH}/lib
+
+    cd -
+}
+
+cd tslib
+  ./build.sh
+cd -
+
+cd iconv
+  ./build.sh
+cd -
+
+compile_qt
+
+
diff --git a/qt5/iconv/build.sh b/qt5/iconv/build.sh
new file mode 100755
index 0000000..b84cfb6
--- /dev/null
+++ b/qt5/iconv/build.sh
@@ -0,0 +1,91 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile libiconv for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PROJ_PATH=`pwd`/../
+ICONV_INST_PATH=${PROJ_PATH}/libs/
+
+if [ -z $CROSSTOOL ] ; then
+   CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+fi
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_libiconv()
+{
+    SRC_NAME=libiconv-1.15
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${ICONV_INST_PATH}/lib/libiconv.so ] ; then
+        msg_banner "Already cross compile $SRC_NAME "
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        wget https://ftp.gnu.org/gnu/libiconv/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX} 
+    cd ${SRC_NAME}
+
+    ./configure --prefix=${ICONV_INST_PATH} ${CONFIG_CROSS}
+    make && make install
+
+    cd -
+}
+
+
+export_cross
+
+compile_libiconv
+
+
+
diff --git a/qt5/iconv/libiconv-1.15.tar.gz b/qt5/iconv/libiconv-1.15.tar.gz
new file mode 100644
index 0000000..abdb6a4
--- /dev/null
+++ b/qt5/iconv/libiconv-1.15.tar.gz
Binary files differ
diff --git a/qt5/tslib/build.sh b/qt5/tslib/build.sh
new file mode 100755
index 0000000..d57028e
--- /dev/null
+++ b/qt5/tslib/build.sh
@@ -0,0 +1,90 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile QT5 for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PROJ_PATH=`pwd`/..
+TSLIB_INST_PATH=${PROJ_PATH}/libs/
+
+if [ -z $CROSSTOOL ] ; then
+   CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+fi
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_tslib()
+{
+    SRC_NAME=tslib-1.16
+    PACK_SUFIX=tar.bz2
+
+
+    if [ -f ${TSLIB_INST_PATH}/lib/libts.so ] ; then
+        msg_banner "Already cross compile $SRC_NAME "
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        wget https://gitlab.com/tslib/tslib/uploads/021755cde4aba79478464459c8a2122c/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xjf ${SRC_NAME}.${PACK_SUFIX} 
+    cd ${SRC_NAME}
+
+    ./configure --prefix=${TSLIB_INST_PATH} ${CONFIG_CROSS}
+    make && make install
+
+    cd -
+}
+
+
+export_cross
+
+compile_tslib
+
+
diff --git a/qt5/tslib/tslib-1.16.tar.bz2 b/qt5/tslib/tslib-1.16.tar.bz2
new file mode 100644
index 0000000..975aa4c
--- /dev/null
+++ b/qt5/tslib/tslib-1.16.tar.bz2
Binary files differ

--
Gitblit v1.9.1